'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var types = _ref.types;

  return {
    visitor: {
      JSXElement: function JSXElement(nodePath) {
        var nodeName = nodePath.node.openingElement.name.name;
        var handler = handlers[nodeName.toLowerCase()];

        if (handler) {
          nodePath.replaceWith(handler(types, nodePath));
        } else {
          var attributeNames = _util2.default.getAttributes(nodePath).map(function (node) {
            return node.name.name.toLowerCase();
          });
          attributeNames.forEach(function (name) {
            var control = controls[name];
            if (control) {
              nodePath.replaceWith(control(types, nodePath));
            }
          });
        }
      }
    }
  };
};

var _TemplateSyntax = require('./syntax/TemplateSyntax');

var _TemplateSyntax2 = _interopRequireDefault(_TemplateSyntax);

var _ConditionalSyntax = require('./syntax/ConditionalSyntax');

var _ConditionalSyntax2 = _interopRequireDefault(_ConditionalSyntax);

var _LoopSyntax = require('./syntax/LoopSyntax');

var _LoopSyntax2 = _interopRequireDefault(_LoopSyntax);

var _util = require('.//util');

var _util2 = _interopRequireDefault(_util);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handlers = {
  template: _TemplateSyntax2.default
};

var controls = {
  'data-if': _ConditionalSyntax2.default,
  'data-for': _LoopSyntax2.default
};